#! /usr/bin/env python
"""
Build Enitiy_mentions Table from sentences Table.

COPYRIGHT 2016, LOUIS RETTER & FRANK GELHAUSEN.
"""

import json
import sys
import unicodedata

ARR_DELIM = '~^~'


# Returns an array representation of an Arraystring 
#   - Arraystring : "['1','1']"
#
def ArrayStringToArray(words):
  words = words.split(ARR_DELIM)
  return words

for row in sys.stdin:
  sentence_id, sentence, words, ner_tags = row.strip().split('\t')
  words = ArrayStringToArray(words)
  ner_tags = ArrayStringToArray(ner_tags)
  sType = ""
  start_index = 0
  phrases = []
  #  extract a tuple (startpos, length, word, sType) from sentence if nertag is different from "O".
  #     - ner_tag : "PERSON", "CITY", ....
  while start_index < len(words):
    index = start_index
    if (ner_tags[index] != "O"):
      sType = ner_tags[index]
      index += 1
      while (index < len(words) and sType == ner_tags[index]):
        index += 1
      length = index-1
      text = ' '.join(words[start_index:index])
      pos = sentence.find(text)
      if (pos != -1):
        if (pos-1 > -1 and sentence[pos-1] == '|'):
          pos = pos - 1
          start_pos = pos - 2
          while (start_pos > -1 and sentence[start_pos] != '['):
            start_pos -= 1
          text = sentence[start_pos+1:pos]
      phrases.append((start_index, length, text, sType))
    start_index = index + 1
  # output to Table as expected by deepdive.conf
  for start_position, length, text, sType, in phrases:
    print '\t'.join(
      [str(x) for x in [
        sentence_id,
        start_position,
        length, 
        text,
        "%s_%d" %(sentence_id, start_position),
        sType
      ]])
  



