#! /usr/bin/env python
"""
COPYRIGHT 2016, LOUIS RETTER & FRANK GELHAUSEN.

takes a certain format of file (provided by Supervisor, in this case "entity_sentences_reduced.txt")
to create the sentences table. (use Schema.sql for detail on structure)

"""


import json
import sys
import unicodedata
from deepdive import *
import ddlib

@tsv_extractor
@returns(lambda
	doc_id = "text",
        sentence = "text",
        words = "text",
        lemma = "text",
        pos_tags = "text",
        dependencies = "text",
        ner_tags = "text",
        sentence_offset = "int",
        sentences_id = "text",
    :[])

def extract(content = "text"):
  with open("../../../udf/../../../../data/output_sentences.txt",'r') as f:
    docId = 0
    phrases = []
    for line in f:
      ner, pos, lemma, words = [], [], [], []
      sentence, tags,nlp, relations = line.split("\t")
      nlpJson = json.loads(nlp)
      wordArray = nlpJson["words"]
      for elements in wordArray:
        ner.append(unicodedata.normalize("NFKD", elements["ner"]).encode("ascii", "ignore"))
        pos.append(unicodedata.normalize("NFKD", elements["pos"]).encode("ascii", "ignore"))
        lemma.append(unicodedata.normalize("NFKD", elements["lemma"]).encode("ascii", "ignore"))
        words.append(unicodedata.normalize("NFKD", elements["token"]).encode("ascii", "ignore"))
      sentence_offset = 0
      # output to table.
      yield[str(docId), 
	sentence, 
	"~^~".join(words), 
	"~^~".join(lemma),
	"~^~".join(pos), 
	"", 
	"~^~".join(ner), 
	sentence_offset, 
	"%s_%s"%(docId, sentence_offset)]
      docId += 1
