#! /usr/bin/env python
"""

searches for person nationality tuples.

COPYRIGHT 2016, LOUIS RETTER & FRANK GELHAUSEN.
"""

import csv, os, sys

APP_HOME = os.environ['APP_HOME']

hasNationality = set()  # set of all person-nationality tuples.
pos_nationality = set() # positive examples.

# For each input tuple
for row in sys.stdin:
  parts = row.strip().split('\t')
  sentence_id, p1_id, p1_text, p2_id, p2_text = parts

  p1_text = p1_text.strip()
  p2_text = p2_text.strip()
  p1_text_lower = p1_text.lower()
  p2_text_lower = p2_text.lower()

  # set all elements mentioned in pos_nationality to 1.
  is_true = '\N'
  if (p1_text_lower, p2_text_lower) in pos_nationality or \
     (p2_text_lower, p1_text_lower) in pos_nationality:
    is_true = '1'

  # Output relation candidates into output table
  print '\t'.join([
    p1_id, p2_id, sentence_id,
    "%s-%s" %(p1_text, p2_text),
    is_true,
    "%s-%s" %(p1_id, p2_id),
    "has_nationality",
    '\N'   # leave "id" blank for system!
    ])

