#! /usr/bin/env python
"""

searches for person organisation tuples.

COPYRIGHT 2016, LOUIS RETTER & FRANK GELHAUSEN.
"""

import csv, os, sys

APP_HOME = os.environ['APP_HOME']

isCEO = set()  # set of all person-organisation tuples.
pos_CEO = set() # positive examples.

# For each input tuple
for row in sys.stdin:
  parts = row.strip().split('\t')
  sentence_id, p1_id, p1_text, p2_id, p2_text = parts

  p1_text = p1_text.strip()
  p2_text = p2_text.strip()
  p1_text_lower = p1_text.lower()
  p2_text_lower = p2_text.lower()

  # set all elements mentioned in pos_CEO to 1.
  is_true = '\N'
  if (p1_text_lower, p2_text_lower) in pos_CEO or \
     (p2_text_lower, p1_text_lower) in pos_CEO:
    is_true = '1'

  # Output relation candidates into output table
  print '\t'.join([
    p1_id, p2_id, sentence_id,
    "%s-%s" %(p1_text, p2_text),
    is_true,
    "%s-%s" %(p1_id, p2_id),
    "is_CEO",
    '\N'   # leave "id" blank for system!
    ])

