#! /usr/bin/env python
"""

COPYRIGHT 2016, LOUIS RETTER & FRANK GELHAUSEN.
"""

import sys
import ddlib     # DeepDive python utility
import ast

ddlib.load_dictionary("../../deepdive-0.7.1/manually_BuildTables/udf/dicts/nationality.txt", dict_id="nationality")
ddlib.load_dictionary("../../deepdive-0.7.1/manually_BuildTables/udf/dicts/not_nationality.txt", dict_id="not_nationality")


# For each input tuple
for row in sys.stdin:
  parts = row.strip().split('\t')

  # Get all fields from a row
  words = parts[0][1:-1].replace("'", '').split(', ')
  lemmas = parts[1][1:-1].replace("'", '').split(', ')
  poses = parts[2][1:-1].replace("'", '').split(', ')
  dependencies = parts[3]
  ners = parts[4][1:-1].replace("'", '').split(', ')
  relation_id = parts[5]
  p1_start, p1_length, p2_start, p2_length = [int(x) for x in parts[6:]]

  # Get a sentence from ddlib -- array of "Word" objects
  #if len(dependencies) == 0:
  #  print >>sys.stderr, str(relation_id) + '\t' + 'DEP_PATH_EMPTY'
#    continue

 # try:
  sentence = ddlib.get_sentence([0, ] * len(words),  [0, ] * len(words), words, lemmas, poses, dependencies, ners)
  #except:
   # print >>sys.stderr, dependencies
    #continue

  # Create two spans of person mentions
  span1 = ddlib.Span(begin_word_id=p1_start, length=p1_length)
  span2 = ddlib.Span(begin_word_id=p2_start, length=p2_length)

  # Features for this pair come in here
  features = set()

  # Get generic features generated by ddlib
  for feature in ddlib.get_generic_features_relation(sentence, span1, span2):
    features.add(feature)
  for feature in features:
    print str(relation_id) + '\t' + feature


